# kdecore Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KCharMacroExpander Class Reference

Abstract base class for single char macro substitutors. More...

`#include <kmacroexpander.h>`

Inheritance diagram for KCharMacroExpander:

[legend]
Collaboration diagram for KCharMacroExpander:

[legend]
List of all members.

## Public Member Functions

| KCharMacroExpander (QChar c= '%')

## Protected Member Functions

virtual int | expandPlainMacro (const QString &str, uint pos, QStringList &ret)
virtual int | expandEscapedMacro (const QString &str, uint pos, QStringList &ret)
virtual bool | expandMacro (QChar chr, QStringList &ret)=0

## Detailed Description

Abstract base class for single char macro substitutors.

Use this instead of the functions in the KMacroExpander namespace if speculatively pre-filling the substitution map would be too expensive.

See KWordMacroExpander for a sample application.

Since:
  3.3

Author:
  Oswald Buddenhagen <ossi@kde.org>

Definition at line 224 of file kmacroexpander.h.

## Constructor & Destructor Documentation

KCharMacroExpander::KCharMacroExpander | ( | QChar | c = `'%'` | ) | `[inline]`

Constructor.

Parameters:

  | c | escape char indicating start of macros, or QChar::null for none

Definition at line 231 of file kmacroexpander.h.

## Member Function Documentation

int KCharMacroExpander::expandPlainMacro | ( | const QString & | str,
|  | uint | pos,
|  | QStringList & | ret
| ) | `[protected, virtual]`

This function is called for every single char within the string if the escape char is QChar::null.

It should determine whether the string starting at `pos` within `str` is a valid macro and return the substitution value for it if so.

Parameters:

  | str | the input string
  | pos | the offset within `str`
  | ret | return value: the string to substitute for the macro

Returns:
  if greater than zero, the number of chars at `pos` in `str` to substitute with `ret` (i.e., a valid macro was found). if less than zero, subtract this value from `pos` (to skip a macro, i.e., substitute it with itself). zero requests no special action.

Reimplemented from KMacroExpanderBase.

Definition at line 434 of file kmacroexpander.cpp.

References expandMacro().

int KCharMacroExpander::expandEscapedMacro | ( | const QString & | str,
|  | uint | pos,
|  | QStringList & | ret
| ) | `[protected, virtual]`

This function is called every time the escape char is found if it is not QChar::null.

It should determine whether the string starting at `pos` witin `str` is a valid macro and return the substitution value for it if so.

Parameters:

  | str | the input string
  | pos | the offset within `str`. Note that this is the position of the occurrence of the escape char
  | ret | return value: the string to substitute for the macro

Returns:
  if greater than zero, the number of chars at `pos` in `str` to substitute with `ret` (i.e., a valid macro was found). if less than zero, subtract this value from `pos` (to skip a macro, i.e., substitute it with itself). zero requests no special action.

Reimplemented from KMacroExpanderBase.

Definition at line 442 of file kmacroexpander.cpp.

References KMacroExpanderBase::escapeChar(), and expandMacro().

virtual bool KCharMacroExpander::expandMacro | ( | QChar | chr,
|  | QStringList & | ret
| ) | `[protected, pure virtual]`

Return substitution list `ret` for single-character macro `chr`.

Parameters:

  | chr | the macro to expand
  | ret | return variable reference. It is guaranteed to be empty when expandMacro is entered.

Returns:
  `true` iff `chr` was a recognized macro name

Referenced by expandEscapedMacro(), and expandPlainMacro().

The documentation for this class was generated from the following files:

- kmacroexpander.h
- kmacroexpander.cpp

This file is part of the documentation for kdecore Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:18:21 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003